/*
** stats.c - holds the cool stats functions
**
** Keith Zaback (krz@wcug.wwu.edu) Apr 98
*/

#include "ipxfury.h"


/* extern */
extern GLOBALS	ifg;


/*
**	SHOW_RECENT_STATS - called every 10 mins or so..
*/
void show_recent_stats()
{
	int		i, seconds;
	int		send, recv, pktsize;
	INTERFACE	*iface;
	
	/* show the recent bandwidth */
	iface = ifg.interfaces;
	for( i = 0; i < ifg.total_interfaces; i++ ) {
		/* get difference in seconds */
		seconds = ifg.now.tv_sec - iface->stats.recent_stats_start.tv_sec;
		
		/* calc B/s */
		send = iface->stats.send_bytes_recent / seconds;
		recv = iface->stats.recv_bytes_recent / seconds;
		
		/* show the info */
		if( iface->stats.send_pkt_recent == 0 ) {
			notice("[%-6s] Sending: %6d B/s   Receiving: %6d B/s\n", iface->name, send, recv);
		} else {
			pktsize = iface->stats.send_bytes_recent / iface->stats.send_pkt_recent;
			notice("[%-6s] Sending: %6d B/s   Receiving: %6d B/s   AvgPkt: %6d Bytes\n", iface->name, send, recv, pktsize);
		}
			

		/* reset time and numbers */
		memcpy(&iface->stats.recent_stats_start, &ifg.now, sizeof(struct timeval));
		iface->stats.send_bytes_recent  = 0;
		iface->stats.recv_bytes_recent  = 0;
		iface->stats.send_pkt_recent	= 0;
		
		/* next interface */
		iface++;
	}
	
	/* done */
	
}


/*
**	SHOW_ALL_STATS - shows everything
*/
void show_all_stats()
{
	/* show some generic stats */
	show_stats(NULL);
	
	/* show the hwaddr table */
	notice("Hardware Address Hash Table (%d entries)\n", ifg.hwaddr_table.entries);
	hash_enum_entries(&ifg.hwaddr_table, (void (*)(int, void*))ether_hash_enum);
	
	/* do they have a udp interface */
	if( interface_find_name("udp") != NULL ) {
		/* show the ips */
		udp_command("ips");
		/* show the map */
		udp_command("map");
	}
	
	/* show the options */
	command_options(NULL);	

	/* done */
	return;

}

	