/*
** timer.c - time functions
**
** Keith Zaback (krz@wcug.wwu.edu) Oct 98
*/

/* includes */
#include <sys/time.h>
#include <unistd.h>


/*
**	TIMER_ADD - adds to a timer
*/
void timer_add(struct timeval *clock, int sec, int usec)
{

	/* add in the sec & usec */
	clock->tv_sec	+= sec;
	clock->tv_usec	+= usec;
	
	/* is usec too big? */
	if( clock->tv_usec > 1000000 ) {
		/* yup -- so add in seconds */
		clock->tv_sec	+= clock->tv_usec / 1000000;
		clock->tv_usec	= clock->tv_usec % 1000000;
	}
	
	/* done */
	return;
}


/*
**	TIMER_CMP - compares timers
**
**	Condition		Return Val
**	c1 < c2			-
**	c1 == c2		0
**	c1 > c2			+
*/

int timer_cmp(struct timeval *c1, struct timeval *c2)
{
	int		d_sec;
	int		d_usec;
	
	d_sec = c1->tv_sec - c2->tv_sec;
	d_usec = c1->tv_usec - c2->tv_usec;

	/* are the seconds the same */	
	if( d_sec == 0 ) {
		return(d_usec);
	} else {
		return(d_sec);
	}

}